Package com.io7m.jregions.core.parameterized.volumes

# Class PVolumeBI<S>

java.lang.Object
com.io7m.jregions.core.parameterized.volumes.PVolumeBI<S>

Type Parameters:
  `S` - A phantom type parameter indicating the coordinate space of the volume

All Implemented Interfaces:
  `PVolumeBIType<S>`, `VolumeSizeValuesBIType`, `VolumeValuesBIType`

public final class PVolumeBI<S> extends Object implements PVolumeBIType<S>

A volume with `BigInteger` coordinates.

The coordinates of the area are given in half-closed form. That is, `minimumX()` refers to the minimum inclusive value on the X axis, and `maximumX()` refers to the maximum exclusive value on the X axis. Likewise for the Y and Z axes.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `PVolumeBI.Builder<S>`
  Builds instances of type `PVolumeBI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <S> PVolumeBI.Builder<S>`
  `builder()`
  Creates a builder for `PVolumeBI`.
  `static <S> PVolumeBI<S>`
  `copyOf(PVolumeBIType<S> instance)`
  Creates an immutable copy of a `PVolumeBIType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `PVolumeBI` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`, `minimumZ`, `maximumZ`.
  `BigInteger`
  `maximumX()`
  `BigInteger`
  `maximumY()`
  `BigInteger`
  `maximumZ()`
  `BigInteger`
  `minimumX()`
  `BigInteger`
  `minimumY()`
  `BigInteger`
  `minimumZ()`
  `static <S> PVolumeBI<S>`
  `of(BigInteger minimumX, BigInteger maximumX, BigInteger minimumY, BigInteger maximumY, BigInteger minimumZ, BigInteger maximumZ)`
  Construct a new immutable `PVolumeBI` instance.
  `String`
  `toString()`
  Prints the immutable value `PVolumeBI` with attribute values.
  `final PVolumeBI<S>`
  `withMaximumX(BigInteger value)`
  Copy the current immutable object by setting a value for the `maximumX` attribute.
  `final PVolumeBI<S>`
  `withMaximumY(BigInteger value)`
  Copy the current immutable object by setting a value for the `maximumY` attribute.
  `final PVolumeBI<S>`
  `withMaximumZ(BigInteger value)`
  Copy the current immutable object by setting a value for the `maximumZ` attribute.
  `final PVolumeBI<S>`
  `withMinimumX(BigInteger value)`
  Copy the current immutable object by setting a value for the `minimumX` attribute.
  `final PVolumeBI<S>`
  `withMinimumY(BigInteger value)`
  Copy the current immutable object by setting a value for the `minimumY` attribute.
  `final PVolumeBI<S>`
  `withMinimumZ(BigInteger value)`
  Copy the current immutable object by setting a value for the `minimumZ` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jregions.core.parameterized.volumes.PVolumeBIType

  `checkPreconditions`

  ### Methods inherited from interface com.io7m.jregions.core.unparameterized.volumes.VolumeValuesBIType

  `sizeX, sizeY, sizeZ`

- ## Method Details

  - ### minimumX

    public BigInteger minimumX()
    Specified by:
      `minimumX` in interface `PVolumeBIType<S>`
    Specified by:
      `minimumX` in interface `VolumeValuesBIType`
    Returns:
      The value of the `minimumX` attribute

  - ### maximumX

    public BigInteger maximumX()
    Specified by:
      `maximumX` in interface `PVolumeBIType<S>`
    Specified by:
      `maximumX` in interface `VolumeValuesBIType`
    Returns:
      The value of the `maximumX` attribute

  - ### minimumY

    public BigInteger minimumY()
    Specified by:
      `minimumY` in interface `PVolumeBIType<S>`
    Specified by:
      `minimumY` in interface `VolumeValuesBIType`
    Returns:
      The value of the `minimumY` attribute

  - ### maximumY

    public BigInteger maximumY()
    Specified by:
      `maximumY` in interface `PVolumeBIType<S>`
    Specified by:
      `maximumY` in interface `VolumeValuesBIType`
    Returns:
      The value of the `maximumY` attribute

  - ### minimumZ

    public BigInteger minimumZ()
    Specified by:
      `minimumZ` in interface `PVolumeBIType<S>`
    Specified by:
      `minimumZ` in interface `VolumeValuesBIType`
    Returns:
      The value of the `minimumZ` attribute

  - ### maximumZ

    public BigInteger maximumZ()
    Specified by:
      `maximumZ` in interface `PVolumeBIType<S>`
    Specified by:
      `maximumZ` in interface `VolumeValuesBIType`
    Returns:
      The value of the `maximumZ` attribute

  - ### withMinimumX

    public final PVolumeBI<S> withMinimumX(BigInteger value)
    Copy the current immutable object by setting a value for the `minimumX` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minimumX
    Returns:
      A modified copy of the `this` object

  - ### withMaximumX

    public final PVolumeBI<S> withMaximumX(BigInteger value)
    Copy the current immutable object by setting a value for the `maximumX` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumX
    Returns:
      A modified copy of the `this` object

  - ### withMinimumY

    public final PVolumeBI<S> withMinimumY(BigInteger value)
    Copy the current immutable object by setting a value for the `minimumY` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minimumY
    Returns:
      A modified copy of the `this` object

  - ### withMaximumY

    public final PVolumeBI<S> withMaximumY(BigInteger value)
    Copy the current immutable object by setting a value for the `maximumY` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumY
    Returns:
      A modified copy of the `this` object

  - ### withMinimumZ

    public final PVolumeBI<S> withMinimumZ(BigInteger value)
    Copy the current immutable object by setting a value for the `minimumZ` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for minimumZ
    Returns:
      A modified copy of the `this` object

  - ### withMaximumZ

    public final PVolumeBI<S> withMaximumZ(BigInteger value)
    Copy the current immutable object by setting a value for the `maximumZ` attribute. An equals check used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumZ
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `PVolumeBI` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `minimumX`, `maximumX`, `minimumY`, `maximumY`, `minimumZ`, `maximumZ`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `PVolumeBI` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static <S> PVolumeBI<S> of(BigInteger minimumX, BigInteger maximumX, BigInteger minimumY, BigInteger maximumY, BigInteger minimumZ, BigInteger maximumZ)
    Construct a new immutable `PVolumeBI` instance.
    Type Parameters:
      `S` - generic parameter S
    Parameters:
      `minimumX` - The value for the `minimumX` attribute
      `maximumX` - The value for the `maximumX` attribute
      `minimumY` - The value for the `minimumY` attribute
      `maximumY` - The value for the `maximumY` attribute
      `minimumZ` - The value for the `minimumZ` attribute
      `maximumZ` - The value for the `maximumZ` attribute
    Returns:
      An immutable PVolumeBI instance

  - ### copyOf

    public static <S> PVolumeBI<S> copyOf(PVolumeBIType<S> instance)
    Creates an immutable copy of a `PVolumeBIType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `S` - generic parameter S
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PVolumeBI instance

  - ### builder

    public static <S> PVolumeBI.Builder<S> builder()
    Creates a builder for `PVolumeBI`.

         PVolumeBI.&lt;S&gt;builder()
            .setMinimumX(java.math.BigInteger) // required minimumX
            .setMaximumX(java.math.BigInteger) // required maximumX
            .setMinimumY(java.math.BigInteger) // required minimumY
            .setMaximumY(java.math.BigInteger) // required maximumY
            .setMinimumZ(java.math.BigInteger) // required minimumZ
            .setMaximumZ(java.math.BigInteger) // required maximumZ
            .build();

    Type Parameters:
      `S` - generic parameter S
    Returns:
      A new PVolumeBI builder